datablock FlyingVehicleData(DropShipVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile   = "./carpet.dts";
	emap	  = true;
	mass	  = 400;
	drag	  = 1.7;
	density     = 4;
	maxDamage = 100.00;
	destroyedLevel = 100.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;
	minMountDist = 3;   
	numMountPoints = 7;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";
	mountThread[4] = "sit";
	mountThread[5] = "sit";
	mountThread[6] = "sit";
	mountThread[7] = "sit";
	lookUpLimit = 0.75;
	lookDownLimit = 0.35;
	jetForce	    = 500;
	jetEnergyDrain    = 8;
	minJetEnergy	= 1;
	massCenter	  = "0 0 -1";
	bodyRestitution   = 0.5;
	bodyFriction	= 0.5;
	minImpactSpeed    = 25;
	softImpactSpeed   = 25;
	hardImpactSpeed   = 50;
	minRollSpeed	= 0;
	maxSteeringAngle  = 0.785;
	maxDrag	  = 100;
	minDrag	  = 50;
	integration    = 4;
	collisionTol   = 0.1;
	contactTol     = 0.1;
	cameraRoll     = false;
	cameraMaxDist  = 13;	  
	cameraLag	= 0.0;
	cameraDecay    = 0.0;
	cameraOffset   = 2.5;
	cameraTilt     = 0.0;
	triggerDustHeight = 3.0;
	dustHeight	  = 1.0;
	numDmgEmitterAreas   = 0;
	damageEmitter[0] = vehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;
	damageEmitter[1] = vehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;
	splashFreqMod     = 300.0;
	splashVelEpsilon  = 0.50;
	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
	exitSplashSoundVelocity    = 2.0;
	softSplashSoundVelocity    = 1.0;
	mediumSplashSoundVelocity  = 2.0;
	hardSplashSoundVelocity    = 3.0;
	collDamageThresholdVel  = 20;
	collDamageMultiplier    = 0.05;
	uiName   = "Drop Ship";
	rideAble = true;
	paintable = true;
	maneuveringForce	  = 6400;
	horizontalSurfaceForce  = 20;
	verticalSurfaceForce    = 20;
	autoInputDamping	  = 0.55;
	steeringForce	     = 1500;
	steeringRollForce	 = 200;
	rollForce		   = 10;
	autoAngularForce	  = 1400;
	rotationalDrag	    = 20;
	autoLinearForce	   = 100;
	maxAutoSpeed		= 10;
	hoverHeight		 = 2.0;
	createHoverHeight	 = 2.0;
	minTrailSpeed	  = 1;
	vertThrustMultiple   = 1.0;
	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;
	burnTime = 500;
	finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;
	minRunOverSpeed    = 2;
	runOverDamageScale = 5;
	runOverPushScale   = 1.2;
	noMounting = 1;
};
function Vehicle::mountVehicle(%this,%vehicle,%slot,%offset)
{
	if(isObject(%this.mountedVehicle[%slot]))
		%this.unMountVehicle(%slot);
	%this.mountedVehicle[%slot] = %vehicle;
	%this.mountedVehicleOffset[%slot] = %offset;
	%this.mountedVehicleHack[%slot] = %this.schedule(25,"mountVehicleHack",%vehicle,%slot);
	return 1;
}
function Vehicle::mountVehicleHack(%this,%vehicle,%slot)
{
	//8:32 AM - Trewse: calculate the offset with sin as x and cos as y
	//8:32 AM - Trewse: then add to those angles and recalculate
	cancel(%this.mountedVehicleHack[%slot]);
	if(!isObject(%vehicle))
	{
		%this.unMountVehicle(%slot);
		return;
	}
	%vehicle.setTransform(vectorAdd(posFromTransform(%this.getTransform()),%this.mountedVehicleOffset[%slot]) SPC getWords(%this.getTransform(),3,5));
	%vehicle.setVelocity(vectorScale(%this.getVelocity(),0.8));
	%this.mountedVehicleHack[%slot] = %this.schedule(25,"mountVehicleHack",%vehicle,%slot);
}
function Vehicle::unMountVehicle(%this,%slot)
{
	cancel(%this.mountedVehicleHack[%slot]);
	%this.mountedVehicle[%slot] = "";
	%this.mountedVehicleOffset[%slot] = "";
	%this.mountedVehicleHack[%slot] = "";
	return 1;
}
package Vehicle_Drop_Ship
{
	function DropShipVehicle::onTrigger(%this,%obj,%slot,%val)
	{
		if(!isObject(getMinigameFromObject(%obj.spawnBrick.getGroup())) || %slot != 2 || !%val)
			return;
		if(isObject(%obj.mountedVehicle["0"]))
		{
			%obj.unMountVehicle(0);
		}
		else
		{
			initContainerRadiusSearch(%obj.getTransform(),15,$TypeMasks::VehicleObjectType);
			while(isObject((%target = containerSearchNext())))
			{
				if(%target == %obj || !isObject(%target.spawnBrick) || getMinigameFromObject(%obj.spawnBrick.getGroup()) != getMinigameFromObject(%target.spawnBrick.getGroup()) || %target.dataBlock.noMounting)
					continue;
				if($AddOn__Gamemode_TeamDeathmatch)
				{
					if(%obj.spawnBrick.tdmAlliedTeam != %target.spawnBrick.tdmAlliedTeam)
					{
						%passengers = 0;
						for(%i=0;%i<=%target.numMountPoints;%i++)
						{
							if(isObject(%target.getMountedObject(%i)))
								%passengers++;
						}
						if(%passengers == 0)
							%obj.mountVehicle(%target,0,"0 0 -7.5");
						else
							continue;
					}
					else
					{
						%obj.mountVehicle(%target,0,"0 0 -7.5");
					}
				}
				else
				{
					%obj.mountVehicle(%target,0,"0 0 -7.5");
				}
				return;
			}
		}
	}
};
activatePackage(Vehicle_Drop_Ship);